//
// Module: 	MUX_2_1
// Design: 	TOP_ MUXES
//
// Description: Multiplexer 2:1
//
// Device: 	Spartan-3 Family 
//
// Date:	April 14, 2003
//
// Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY 
//              WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY 
//              IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR/
//              A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
//
//  Copyright (c) 2003 Xilinx, Inc.  All rights reserved.
//---------------------------------------------------------------------------------------
//
module MUX_2_1 (DATA_I, SELECT_I, DATA_O);

input [1:0]DATA_I;
input SELECT_I;

output DATA_O;
reg DATA_O;


always @ (DATA_I or SELECT_I)

    case (SELECT_I)
        1'b0 : DATA_O <= DATA_I[0];
	1'b1 : DATA_O <= DATA_I[1];
	default : DATA_O <= 1'bx;
    endcase

endmodule